//przykladowe rozwiazanie problemu flagi holenderskiej

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>

const int maxsize = 9;

using namespace std;

void swap(int *t, int i, int j){
	int pom=t[i];
     t[i]=t[j];
	t[j]=pom;
}

void printing(int *t, int size){
	cout<<endl;
	for(int i=0;i<size;i++)
	cout<<t[i]<<", ";
}


// zakladamy, ze w tablicy t[l,..., r-1]
// mamy elementy o wartosciach 0,1,2
// Porzadkujemy je w czasie liniowym.
void dutchflag(int* t, int right);

int test(); //funkcja testujaca poprawnosc sortowana

int main(void){
	srand(time(NULL)); //startujemy generator liczb pseudolosowych dla funkcji test()	
	if(test()==0) 
		cout<<endl<<"Blad algorytmu sortowania"; //testowanie
	int t[maxsize]={1,2,0,1,1,0,2,0,1};
	cout<<endl;
	for(int i=0;i<maxsize;i++)
		cout<<t[i]<<", ";
	dutchflag(t,maxsize);
	cout<<endl;
	for(int i=0;i<maxsize;i++)
		cout<<t[i]<<", ";
	cout<<endl<<flush;
	system("read -p \"Press [Enter]\" "); //Linux
	//system("pause"); //DOS
	return 1;
}


void dutchflag(int *t, int right){
	int i=0, j=0;
	int k=right-1;
	while(j<k){
		while(j<k && t[j]<2){
			if(t[j]==0){
				swap(t,i,j);
				i++;j++;
			}
			else
				j++;
		};
		while(j<k && t[k]==2){
			k--;
		}
		if(j<k){
			swap(t,j,k);
		}
	}

}



int test(){
	int t[30];
	for(int i=0;i<=50;i++){
		for(int k=0;k<30;k++)     //testujemy dutchflag
			t[k]=rand()%3;
		dutchflag(t,30);
		for(int j=0;j<29;j++)
			if(t[j]>t[j+1]){
				cout<<"Blad: ";
				printing(t,30);
				return 0; // tablica nie zostala posortowana
			}

	}
	return 1; // wszystko poszlo dobrze
}